/*
 * PjOde_IP.java
 *
 * Created on December 29, 2004, 6:42 PM
 */

package GrapherODE;

import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.datatransfer.*;
import java.lang.SecurityManager;
import java.awt.*;
import jv.objectGui.PsTabPanel;
import jv.object.PsDebug;
import jv.object.PsUpdateIf;
import jv.project.PvDisplayIf;
import jv.project.PjProject_IP;
import jv.object.PsPanel;
import jv.thirdParty.ruler.*;
/**
 *
 * @author David
 */
public class PjOde_IP extends PjProject_IP implements ItemListener, ActionListener {
    protected       PsTabPanel                      m_tabpanel;
    protected       PsPanel                 m_pMain;
    protected       PsPanel                 m_pGraphs;
    protected       PsPanel                 m_pWindow;
    protected       PjOde                   m_PjOde;
    protected       PsPanel                 m_pSel;
    protected       PsPanel                 m_pFunc;
    protected       PsPanel                 m_pBnds;
    protected       PsPanel                 m_pICsLabel;
    protected       PsPanel                 m_p2DW;
    protected       PsPanel                 m_p3DW;
    protected       PsPanel                 m_p2DLabels;
    protected       PsPanel                 m_p2DLegend;
    protected       PsPanel                 m_p3DLabels;
    protected       PsPanel                 m_p2D;
    protected       PsPanel                 m_p3D;
    protected       PsPanel                 m_vecIP;
    protected       List[]                  m_l2D;
    protected       List[]                  m_l3D;
    protected       Button                          m_bToClipboard2D;
    protected       Button                          m_bToClipboard3D;
    protected       boolean                         m_bCanUseClipboard = false;
    protected       Checkbox                m_cShow2D;
    protected       Checkbox                m_cShow3D;
    protected       Checkbox                m_cShow3Daxes;
    protected       Checkbox                m_cAutoScale2D;
    protected       Checkbox                m_cShowVF;
    protected       Checkbox                m_cShowMultiple;
    
    protected       Choice                  m_cOrder;
    protected       Choice                  m_cRKOrder;
    
    /** Creates a new instance of PjOde_IP */
    public PjOde_IP() {
        super();
        addTitle("ODE Grapher");
        if (getClass() == PjOde_IP.class) {
            init();
        }
    }
    
    public void init() {
        super.init();
        //add Choice for order/system choices
        
        m_tabpanel = new PsTabPanel();
        add(m_tabpanel);
        m_tabpanel.init();
        
        m_pMain = new PsPanel();
        
        m_pSel = new PsPanel(new GridLayout(1, 2));
        m_pSel.add(new Label("ODE type:"));
        m_cOrder = new Choice();
        m_cOrder.addItemListener(this);
        m_cOrder.add("First order ODE");
        m_cOrder.add("Second order ODE");
        m_cOrder.add("Third order ODE");
        m_cOrder.add("Fourth order ODE");
        m_cOrder.add("2 variable system");
        m_cOrder.add("3 variable system");
        m_cOrder.select(0);
        m_pSel.add(m_cOrder);
        
        m_pMain.add(m_pSel);
        
        m_pFunc = new PsPanel();
        m_pMain.add(m_pFunc);
        
                
        m_pMain.addLine(1);
        
        m_pBnds = new PsPanel();
        m_pMain.add(m_pBnds);
        m_pMain.addLine(1);
       try {
                  
                    SecurityManager sm = System.getSecurityManager();
                    if (sm != null) sm.checkSystemClipboardAccess();
                    
                    m_bCanUseClipboard = true;
                    Panel buttons = new Panel(new GridLayout(1,2));
                    m_bToClipboard2D = new Button ("Copy 2D to Clipboard");
                    m_bToClipboard2D.addActionListener(this);
                    buttons.add(m_bToClipboard2D);
                    m_bToClipboard3D = new Button ("Copy 3D to Clipboard");
                    m_bToClipboard3D.addActionListener(this);
                    buttons.add(m_bToClipboard3D);
                    m_pMain.add(buttons);
                }
                catch (SecurityException e) {
                     
                   }
        
        
        m_pGraphs = new PsPanel();
        
        m_cShow2D = new Checkbox("Show 2D graph", true);
        m_cShow2D.addItemListener(this);
        m_pGraphs.add(m_cShow2D);
        
        m_p2DW = new PsPanel();
        m_p2DLabels = new PsPanel(new GridLayout(1,2));
        m_p2DLabels.add(new Label("Horiz"));
        m_p2DLabels.add(new Label("Vertical"));
        m_p2DW.add(m_p2DLabels);
        m_p2D = new PsPanel(new GridLayout(1,2));
        m_l2D = new List[2];
        m_l2D[0] = new List(4,false);
        m_l2D[0].addItemListener(this);
        m_l2D[1] = new List(4, true);
        m_l2D[1].addItemListener(this);
        m_p2D.add(m_l2D[0]);
        m_p2D.add(m_l2D[1]);
        m_p2DW.add(m_p2D);
        m_p2DLegend = new PsPanel(new GridLayout(1,5));
        m_p2DLegend.add(new Label("Legend:"));
        m_p2DW.add(m_p2DLegend);
        m_cShowVF = new Checkbox("Show Vector Field",false);
        m_cShowVF.addItemListener(this);
        m_p2DW.add(m_cShowVF);
        m_cShowMultiple = new Checkbox("Show Multiple Solutions");
        m_cShowMultiple.addItemListener(this);
        m_p2DW.add(m_cShowMultiple);
        
        m_pGraphs.add(m_p2DW);
        m_pGraphs.addLine(1);
        
        m_cShow3D = new Checkbox("Show 3D graph");
        m_cShow3D.addItemListener(this);
        m_pGraphs.add(m_cShow3D);
        
        m_p3DW = new PsPanel();
        m_p3DLabels = new PsPanel(new GridLayout(1,3));
        m_p3DLabels.add(new Label("x axis"));
        m_p3DLabels.add(new Label("y axis"));
        m_p3DLabels.add(new Label("z axis"));
        m_p3DW.add(m_p3DLabels);
        m_p3D = new PsPanel(new GridLayout(1,3));
        m_l3D = new List[3];
        m_l3D[0] = new List(4, false);
        m_l3D[0].addItemListener(this);
        m_l3D[1] = new List(4, false);
        m_l3D[1].addItemListener(this);
        m_l3D[2] = new List(4, false);
        m_l3D[2].addItemListener(this);
        m_p3D.add(m_l3D[0]);
        m_p3D.add(m_l3D[1]);
        m_p3D.add(m_l3D[2]);
        m_p3DW.add(m_p3D);
        m_cShow3Daxes = new Checkbox("Show axes");
        m_cShow3Daxes.addItemListener(this);
        m_p3DW.add(m_cShow3Daxes);
        m_pGraphs.add(m_p3DW);
        m_p3DW.setVisible(false);
        
        
    }
    
   
    public void setParent(PsUpdateIf parent) {
		super.setParent(parent);
                m_PjOde = (PjOde)parent;
                
                m_pFunc.add(m_PjOde.m_func.assureInspector(PsPanel.INFO,PsPanel.INFO_EXT));
                
                
                
                m_pBnds.add(m_PjOde.m_tMin.assureInspector(PsPanel.INFO, PsPanel.INFO_EXT));
                m_pBnds.add(m_PjOde.m_tMax.assureInspector(PsPanel.INFO, PsPanel.INFO_EXT));
                m_pBnds.add(m_PjOde.m_tStepSize.assureInspector(PsPanel.INFO, PsPanel.INFO_EXT));
                
                PsPanel m_pICs = new PsPanel(new GridLayout(1,2));
                m_pICs.add(new Label("Initial Conditions"));
                m_pICsLabel = new PsPanel();
                m_pICs.add(m_pICsLabel);
                m_pBnds.add(m_pICs);
                m_pBnds.add(m_PjOde.m_pICs);
                
                m_PjOde.setupFunc(1,1);
                setFuncLabel();
                
                m_pWindow = new PsPanel();
                m_pWindow.add(m_PjOde.m_clipbounds.assureInspector(PsPanel.INFO,PsPanel.INFO_EXT));
                m_cAutoScale2D = new Checkbox("Scale 2D graph to curves");
                m_cAutoScale2D.addItemListener(this);
                m_pWindow.add(m_cAutoScale2D);
                m_vecIP = m_PjOde.m_vecfld.assureInspector(PsPanel.INFO, PsPanel.INFO_EXT);
                m_vecIP.setVisible(false);
                m_pWindow.add(m_vecIP);
                
                PsPanel m_pRKSel = new PsPanel(new GridLayout(1, 2));
                m_pRKSel.add(new Label("Integrator Order:"));
                m_cRKOrder = new Choice();
                m_cRKOrder.addItemListener(this);
                m_cRKOrder.add("1st order RK / Euler's");
                m_cRKOrder.add("2nd order RK");
                m_cRKOrder.add("3rd order RK");
                m_cRKOrder.add("4th order RK");
                m_cRKOrder.select(3);
                m_pRKSel.add(m_cRKOrder);
                m_pWindow.add(m_pRKSel);
                
                
                m_tabpanel.addPanel("ODE",m_pMain);
                m_tabpanel.addPanel("Graphs", m_pGraphs);
                m_tabpanel.addPanel("Window",m_pWindow);
                m_tabpanel.validate();

                changeOrder();
    }
    
    /** sets the initial condition labels.  Call after calling m_PjOde.setupFunc() */
    public void setFuncLabel() {
        int num = m_PjOde.m_indepVars.length - 1;
        
        m_l2D[0].removeAll();
        m_l2D[1].removeAll();
        m_l3D[0].removeAll();
        m_l3D[1].removeAll();
        m_l3D[2].removeAll();
        
        m_pICsLabel.removeAll();
        m_pICsLabel.setLayout(new GridLayout(1,num));
        for (int i=0; i < num;i++) {
            m_pICsLabel.add(new Label(m_PjOde.m_indepVars[i]));
            m_l2D[0].add(m_PjOde.m_indepVars[i]);
            m_l2D[1].add(m_PjOde.m_indepVars[i]);
            m_l3D[0].add(m_PjOde.m_indepVars[i]);
            m_l3D[1].add(m_PjOde.m_indepVars[i]);
            m_l3D[2].add(m_PjOde.m_indepVars[i]);
        }
        
        m_pICsLabel.add(new Label(m_PjOde.m_indepVars[num]));
        m_l2D[0].add("t");
        m_l3D[0].add("t");
        
        m_pFunc.removeAll();
        m_pFunc.add(m_PjOde.m_func.assureInspector(PsPanel.INFO,PsPanel.INFO_EXT));
        
       
        validate();
    }
    
    public void itemStateChanged(ItemEvent event) {
		Object source = event.getSource();
                if (source==m_cOrder) {
                    changeOrder();
                }
                if (source==m_cRKOrder) {
                    m_PjOde.m_RKorder = m_cRKOrder.getSelectedIndex() + 1;
                    m_PjOde.doRK();
                }
                if (source == m_l2D[0]) {
                    if (m_l2D[1].getSelectedIndexes().length > 0) {
                        set2Daxes();
                        m_PjOde.make2Dgraphs();
                    } 
                    
                }
                if (source == m_l2D[1]) {
                    if (m_l2D[1].getSelectedIndexes().length > 0) {
                        m_PjOde.m_do2d = true;
                        set2Daxes();
                        m_PjOde.make2Dgraphs();
                    } else {
                        m_PjOde.m_do2d = false;
                        m_PjOde.axes.showNames(false);
                        m_PjOde.m_2dpolys.setVisible(false);
                        m_PjOde.m_2dpolys.update(m_PjOde.m_2dpolys);
                        m_PjOde.m_disp2D.update(m_PjOde.m_disp2D);
                    }
                }
                if (source == m_l3D[0]) {
                    if ((m_l3D[0].getSelectedIndex() > -1) && (m_l3D[1].getSelectedIndex() > -1) && (m_l3D[2].getSelectedIndex() > -1)) {
                        set3Daxes();
                        m_PjOde.make3Dgraph();
                        
                    } 
                }
                if (source == m_l3D[1]) {
                    if ((m_l3D[0].getSelectedIndex() > -1) && (m_l3D[1].getSelectedIndex() > -1) && (m_l3D[2].getSelectedIndex() > -1)) {
                        set3Daxes();
                        m_PjOde.make3Dgraph();
                    } 
                }
                if (source == m_l3D[2]) {
                    if ((m_l3D[0].getSelectedIndex() > -1) && (m_l3D[1].getSelectedIndex() > -1) && (m_l3D[2].getSelectedIndex() > -1)) {
                        set3Daxes();
                        m_PjOde.make3Dgraph();
                    } 
                }
                if (source == m_cShow2D) {
                    m_PjOde.setDP(m_cShow2D.getState(),m_cShow3D.getState());
                    m_p2DW.setVisible(m_cShow2D.getState());
                    m_PjOde.m_do2d = m_cShow2D.getState();
                    if (m_PjOde.m_do2d) { set2Daxes(); m_PjOde.make2Dgraphs();}
                }
                if (source == m_cShow3D) {
                    m_PjOde.setDP(m_cShow2D.getState(),m_cShow3D.getState());
                    m_p3DW.setVisible(m_cShow3D.getState());
                    m_PjOde.m_do3d = m_cShow3D.getState();
                    if (m_PjOde.m_do3d) { set3Daxes(); m_PjOde.make3Dgraph();}
                }
                if (source == m_cAutoScale2D) {
                    m_PjOde.m_autoScale2D = m_cAutoScale2D.getState();
                    m_PjOde.drawXYgrid();
                }
                if (source == m_cShow3Daxes) {
                    if (m_cShow3Daxes.getState()) {
                        m_PjOde.m_disp3D.showAxes(true);
                        m_PjOde.m_disp3D.showBndBox(true);
                        set3Daxes();
                    } else {
                        m_PjOde.m_disp3D.showAxes(false);
                        m_PjOde.m_disp3D.showBndBox(false);
                    }
                    
                }
                if (source == m_cShowVF) {
                    m_PjOde.m_dovf = m_cShowVF.getState();
                    if (m_PjOde.m_dovf) {
                        m_vecIP.setVisible(true);
                        m_PjOde.m_vecfld.setVisible(true);
                        m_PjOde.drawXYgrid();
                    } else {
                        m_vecIP.setVisible(false);
                        m_PjOde.m_vecfld.setVisible(false);
                        m_PjOde.m_vecfld.update(m_PjOde.m_vecfld);
                    }
                }
                if (source == m_cShowMultiple) {
                    m_PjOde.m_bMultiple = m_cShowMultiple.getState();
                    if (!m_PjOde.m_bMultiple) {
                        m_PjOde.make2Dgraphs();
                    }
                }
                
    }
    
    public void set2Daxes() {
                        
                        
                        m_PjOde.m_2dx = m_l2D[0].getSelectedIndex();
                        m_PjOde.m_2dy = m_l2D[1].getSelectedIndexes();
                        
                        if (m_cOrder.getSelectedIndex() == 4) { // if system, see if VF is ok
                                if ((m_PjOde.m_2dx < 2) && (m_PjOde.m_2dy.length ==1) && (m_PjOde.m_2dx != m_PjOde.m_2dy[0])) {
                                    m_cShowVF.setEnabled(true);
                                } else  {
                                    m_cShowVF.setEnabled(false);
                                    m_vecIP.setVisible(false);
                                    if (m_PjOde.m_dovf) {
                                        m_cShowVF.setState(false);
                                       m_PjOde.m_dovf = false;
                                       m_PjOde.m_vecfld.setVisible(false);
                                       m_PjOde.m_vecfld.update(m_PjOde.m_vecfld);
                                     }
                                }
                        } else if (m_cOrder.getSelectedIndex() == 0) { //if first order, see if VF is ok
                            if (m_PjOde.m_2dx != m_PjOde.m_2dy[0]) {
                                m_cShowVF.setEnabled(true);
                            } else  {
                                m_vecIP.setVisible(false);
                                m_cShowVF.setEnabled(false);
                                if (m_PjOde.m_dovf) {  
                                    m_cShowVF.setState(false);
                                    m_PjOde.m_dovf = false;
                                    m_PjOde.m_vecfld.setVisible(false);
                                    m_PjOde.m_vecfld.update(m_PjOde.m_vecfld);

                                }
                           }
                        } else { m_cShowVF.setEnabled(false); }
                        
                        m_PjOde.axes.setNames(new String[] {m_l2D[0].getSelectedItem(), arrayToString(m_l2D[1].getSelectedItems(),","),""});
                        m_PjOde.axes.showNames(true);
                        m_PjOde.axes.update(m_PjOde.axes);
                        m_p2DLegend.removeAll();
                        m_p2DLegend.add(new Label("Legend:"));
                        for (int i=0; i < m_PjOde.m_2dy.length;i++) {
                            Label l = new Label(m_l2D[1].getSelectedItems()[i]);
                            l.setForeground(m_PjOde.m_colorlist[i]);
                            
                            
                            m_p2DLegend.add(l,i+1);
                        }
                        m_p2DLegend.validate();
                        m_PjOde.m_disp2D.update(m_PjOde.m_disp2D);
   
    }
    
    public void set3Daxes() {
        m_PjOde.m_3dx = m_l3D[0].getSelectedIndex();
        m_PjOde.m_3dy = m_l3D[1].getSelectedIndex();
        m_PjOde.m_3dz = m_l3D[2].getSelectedIndex();
        if (m_cShow3Daxes.getState()) {
            PgAxes axes = ((jv.viewer.PvDisplay)m_PjOde.m_disp3D).getAxes();
            axes.setMode(PgAxes.AXES_3DCORNER);
            axes.setNames(new String[] {m_l3D[0].getSelectedItem(), m_l3D[1].getSelectedItem(),m_l3D[2].getSelectedItem()});
            axes.showNames(true);
            axes.update(axes);
        }
        m_PjOde.m_disp3D.update(m_PjOde.m_disp3D);
    }
    
    public String arrayToString (String[] a, String separator) {
    StringBuffer result = new StringBuffer(a[0]);// start with first element
    if (a.length > 1) {
         for (int i=1; i<a.length; i++) {
            result.append(separator);
            result.append(a[i]);
        }
    }
    return result.toString();
}
    
    public void actionPerformed(ActionEvent event) {
		
		Object source = event.getSource();
                if (source == m_bToClipboard2D){
                    PvDisplayIf disp = m_PjOde.get2DDisplay();
                    ImageSelection contents = new ImageSelection(disp.getImage());
                    Clipboard systemClipboard = Toolkit.getDefaultToolkit().getSystemClipboard();
                    systemClipboard.setContents(contents, null);
                }
                if (source == m_bToClipboard3D){
                    PvDisplayIf disp = m_PjOde.get3DDisplay();
                    ImageSelection contents = new ImageSelection(disp.getImage());
                    Clipboard systemClipboard = Toolkit.getDefaultToolkit().getSystemClipboard();
                    systemClipboard.setContents(contents, null);
                }
    }
    
    public void changeOrder() {
  //              if (m_cShow2D.getState()) {
  //                       m_PjOde.m_2dpolys.setVisible(false);
  //                      m_PjOde.m_2dpolys.update(m_PjOde.m_2dpolys);
  //                  }
                if (m_PjOde.m_dovf) {
                        m_PjOde.m_dovf = false;
                        m_PjOde.m_vecfld.setVisible(false);
                        m_PjOde.m_vecfld.update(m_PjOde.m_vecfld);
                        m_cShowVF.setState(false);
                        m_cShowVF.setEnabled(false);
                }
                   switch(m_cOrder.getSelectedIndex()){                        
                       case 0: 
                            m_PjOde.setupFunc(1,1);
                            setFuncLabel();
                            break;
                        case 1:
                            m_PjOde.setupFunc(2,1);
                            setFuncLabel();
                            break;
                        case 2:
                            m_PjOde.setupFunc(3,1);
                            setFuncLabel();
                            break;
                        case 3:
                            m_PjOde.setupFunc(4,1);
                            setFuncLabel();
                            break;
                        case 4:
                            m_PjOde.setupFunc(1,2);
                            setFuncLabel();
                            break;
                        case 5:
                            m_PjOde.setupFunc(1,3);
                            setFuncLabel();
                            break;
                    }
                    m_l2D[0].select(m_PjOde.m_indepVars.length-1);
                    m_l2D[1].select(0);
                    if (m_PjOde.m_do2d) {set2Daxes();}
                    m_l3D[0].select(m_PjOde.m_indepVars.length-1);
                    m_l3D[1].select(0);
                    if (m_PjOde.m_indepVars.length > 2) {
                        m_l3D[2].select(1);
                    } else { m_l3D[2].select(0); }
                    if (m_PjOde.m_do3d) {set3Daxes(); }
                    m_PjOde.doRK();
    }
    

}
