/*
 * PuDomain_IP.java
 *
 * Created on January 4, 2005, 11:14 PM
 */

package GrapherODE;

import java.awt.*;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;

import jv.object.PsDebug;
import jv.object.PsPanel;
import jv.object.PsUpdateIf;
import jv.project.PgGeometryIf;
/**
 *
 * @author David
 */
public class PuDomain_IP extends PsPanel implements ItemListener {
        protected	PuDomain                                m_PuDomain;
	protected	PsPanel					m_pBounds;
        protected       PsPanel                                 m_pOptions;
        protected       PsPanel                                 m_pSlice;
     
        protected       Checkbox                                m_cSclVecs;
        protected       Checkbox[]                              m_cShowSlice;

        
    /** Creates a new instance of PuDomain_IP */
    public PuDomain_IP() {
        super();
		if (getClass() == PuDomain_IP.class) {
			init();
		}
    }
    
    public void init() {
                super.init();
		
                
                
                m_pSlice = new PsPanel();
                add (m_pSlice);
                
		m_pBounds = new PsPanel();
  		add(m_pBounds);
                
                m_pOptions = new PsPanel();
                add(m_pOptions);
		
              
                
	
    }
    
    /**
	 * Set parent of panel which supplies the data inspected by the panel.
	 */
	public void setParent(PsUpdateIf parent) {
		super.setParent(parent);
             
		m_PuDomain = (PuDomain)parent;
                
                if (m_PuDomain.m_bIsVF) {
                    m_cSclVecs = new Checkbox("Scale Vecs to one length");
                    m_cSclVecs.addItemListener(this);
                    m_pOptions.add(m_cSclVecs);
                } 
     
                    
                m_pBounds.removeAll();
                for (int i = 0; i < m_PuDomain.numvariables; i++) {
                    m_pBounds.add(m_PuDomain.m_var[i][0].assureInspector(PsPanel.INFO,PsPanel.INFO_EXT));
                    m_pBounds.add(m_PuDomain.m_var[i][1].assureInspector(PsPanel.INFO,PsPanel.INFO_EXT));
                    if (m_PuDomain.m_numDiscr == -1) {
 //                    if (!m_PuDomain.m_bOneDiscr) {
                        m_pBounds.add(m_PuDomain.m_discr[i].assureInspector(PsPanel.INFO,PsPanel.INFO_EXT));
                    }
                 }
                 if (m_PuDomain.m_numDiscr == 1) {
//                if (m_PuDomain.m_bOneDiscr) {
                    m_pBounds.add(m_PuDomain.m_discr[0].assureInspector(PsPanel.INFO,PsPanel.INFO_EXT));
                }
               
                if (m_PuDomain.m_bIsVF) {
                    m_pBounds.add(m_PuDomain.m_veclength.assureInspector(PsPanel.INFO,PsPanel.INFO_EXT));
                }
                
                if (m_PuDomain.m_bAllowSlices) {
                    m_pSlice.setLayout(new GridLayout(1,m_PuDomain.numvariables));
                    m_cShowSlice = new Checkbox[m_PuDomain.numvariables];
                    for (int i = 0; i < m_PuDomain.numvariables; i++) { 
                        m_cShowSlice[i] = new Checkbox("Show " + m_PuDomain.m_varNames[i] +" slice");
                        m_cShowSlice[i].addItemListener(this);
                        m_pSlice.add(m_cShowSlice[i]);
                    }
                }
                

        }
	/**
	 * Update the panel whenever the parent has changed somewhere else.
	 * Method is invoked from the parent or its superclasses.
	 */
	public boolean update(Object event) {
		if (PsDebug.NOTIFY) PsDebug.notify("isShowing = "+isShowing());
		return super.update(event);
	}


        public void itemStateChanged(ItemEvent event) {
		Object source = event.getSource();
                if (source == m_cSclVecs) {
                    m_PuDomain.m_bSclVecs = m_cSclVecs.getState();
//                    m_PuDomain.computeGeom();
                    m_PuDomain.update(m_PuDomain);
                }
                if (m_PuDomain.m_bAllowSlices) {
                    for (int i=0; i< m_PuDomain.numvariables;i++) {
                        if (source == m_cShowSlice[i]) { 
                            m_PuDomain.m_bShowSlice[i] = m_cShowSlice[i].getState();
                            m_PuDomain.m_var[i][1].setEnabled(!m_PuDomain.m_bShowSlice[i]);
                            if (m_PuDomain.m_numDiscr == -1) { 
                                m_PuDomain.m_discr[i].setEnabled(!m_PuDomain.m_bShowSlice[i]);
                            }
                            if (m_PuDomain.m_bShowSlice[i]) {
                                double temp = m_PuDomain.m_varValBU[i];
                                m_PuDomain.m_varValBU[i] = m_PuDomain.m_var[i][0].getValue();
                                m_PuDomain.m_var[i][0].setValue(temp);
                            } else {
                                double temp = m_PuDomain.m_var[i][0].getValue();
                                m_PuDomain.m_var[i][0].setValue(m_PuDomain.m_varValBU[i]);
                                m_PuDomain.m_varValBU[i] = temp;
                            }
                            m_PuDomain.update(m_PuDomain);
                        }
                    }
                }
	}
}

